indexing
	description: "A helpful word wrapper function"
	author: "Bernd Schoeller"
	copyright: "(c) 2006 Bernd Schoeller (bernd@fams.de)"
	license: "see included README.txt file"
	date: "$Date: 2006/03/25 10:13:50 $"
	revision: "$Revision: 1.1 $"
	note: "This class should actually belong to some other library on strings"

class
	OP_WORD_WRAP

feature
	
	terminal_width: INTEGER is 79
		-- Width of the terminal for word wrapping the descriptions
	
	word_wrap (a_text: STRING; indent: INTEGER): STRING is
			-- Word-wrapped version of `a_text', indented on the following lines
			-- by `indent' characters
		require
			text_not_void: a_text /= Void
			indent_not_too_small: indent >= 0
			indent_not_too_large: indent < terminal_width
		local
			line_length: INTEGER
			position: INTEGER
			search_position: INTEGER
			fill_string: STRING
		do
			Result := ""
			create fill_string.make_filled (' ', indent)
			line_length := terminal_width
			from		
				position := 1
			until
				position > a_text.count
			loop
				if a_text.count <= position+line_length then
					Result.append (a_text.substring (position, a_text.count))
					position := a_text.count+1
				else
					from
						search_position := position+line_length
					until
						search_position = position or a_text.item (search_position) = ' '
					loop
						search_position := search_position - 1
					end
					if search_position = position then
						search_position := position+line_length-1
						Result.append (a_text.substring (position, search_position))
					else
						Result.append (a_text.substring (position, search_position-1))
					end
					position := search_position+1
					Result.append ("%N")
					Result.append (fill_string)						
					line_length := terminal_width-indent
				end
			end
		end

end
